/* -*- Emacs Mode: C++ -*- */

/*	link.h - Link Class header

	Copyright (C) 1989, Integrity Software
	Author: Isaac J. Salzman (salzman@rand.org)

	This software may be freely used/modified/distributed
	as desired so long as this copyright notice remains
	in tact.
*/

/*
 *------------------------------------------------------------------
 * $Header: /tmp_mnt/amnt/lh/salzman/src/class/RCS/link.h,v 1.1 89/09/17 15:01:33 salzman Exp Locker: salzman $
 *------------------------------------------------------------------
 * $Log:	link.h,v $
 * Revision 1.1  89/09/17  15:01:33  salzman
 * Initial revision
 * 
*/

/*  linked list class for C++/THINK Object C */

#ifndef _H_link
#define _H_link

#include "class.h"
#include "defs.h"

PREDEC_CLASS(Link);

class Link ROOT		/* this is a root class! */
{
  PRIVATE
    class Link *nextp;
    class Link *prevp;
    class Link *tailp;

  PUBLIC
    DECL_INIT(Link)();
    DECL_DEST(Link)(void);
    
    int append(Link *);
    int prepend(Link *);
    int insert(Link *);

    class Link *next(void);
    class Link *prev(void);

    void showlist(void);
    void rshowlist(void);

    class Link *find(char *);

    virtual void showval(void);

    virtual int compare(char *);

    
};

#endif /* _H_link */
